
#=============================================================================
# Setup Paths
#=============================================================================


# Paths for 64 bit compilation using the Sun Fote compiler. 
INCLUDES_CCFORTE64 = -I/home/hgsc/include/stlport/ $(INCLUDES_CC)
LIB_PATHSFORTE64 = -L/home/hgsc/lib/ -L$(CBT_LIB) 
FORTE_LIB_PATHS = -L/hgsc/forte/lib/
CCFLAGSFORTE64 = -DFORTE64 -fast -xtarget=ultra -xarch=v9 


# Paths for 64 bit compilation using the Sun Fote compiler. 
INCLUDES_CCFORTE64g = -I/home/hgsc/include/stlport/ $(INCLUDES_CC)
LIB_PATHSFORTE64g = -L/home/hgsc/lib/ -L$(CBT_LIB) 
FORTE_LIB_PATHSg = -L/hgsc/forte/lib/
CCFLAGSFORTE64g = -DFORTE64 -g -D_STLP_DEBUG -xtarget=ultra -xarch=v9 


# STLPort has some debugging features, so provide a way to compile with STLPort 
# and use these debugging features. 
INCLUDES_STLPORT = -I/home/hgsc/include/hgsc.compbio/stlport/ $(INCLUDES_CC)


#=============================================================================
# Object files. 
#=============================================================================
# Build lists of object files from the targets. 

forte64 =$(libtargets:%=$(CBT_LIB)/%.forte64.o)
forte64g =$(libtargets:%=$(CBT_LIB)/%.forte64g.o)

stlportobj =$(libtargets:%=$(CBT_LIB)/%.stlport.o)
faststlportobj =$(libtargets:%=$(CBT_LIB)/%.faststlport.o)

#thorium64objs =$(libtargets:%=$(CBT_LIB)/%.thorium64.o)

regextargetobjs = $(REGEX_O:%=RegexSupport/lib/%)



# Make 64-bit Solairs version using the forte compiler. 
forte64: $(CBT_LIB)/libcbt.forte64.a

# Make 64-bit Solairs version using the forte compiler. 
forte64g: $(CBT_LIB)/libcbt.forte64g.a

# Compile 64-bit version of libraries using forte compiler
$(CBT_LIB)/%.forte64.o: $(CBT_SRC)/%.cc 
	/hgsc/forte/bin/CC $(CCFLAGSFORTE64) $(INCLUDES_CCFORTE64) -c -o $(CBT_LIB)/$*.forte64.o $(CBT_SRC)/$*.cc

# Compile 64-bit version of libraries using forte compiler
$(CBT_LIB)/%.forte64g.o: $(CBT_SRC)/%.cc 
	/hgsc/forte/bin/CC $(CCFLAGSFORTE64g) $(INCLUDES_CCFORTE64g) -c -o $(CBT_LIB)/$*.forte64g.o $(CBT_SRC)/$*.cc

# Make 64-bit forte object files into a library archive. 
$(CBT_LIB)/libcbt.forte64.a: $(forte64)
	/hgsc/forte/bin/CC -xar -o $@  $(forte64)

# Make 64-bit forte object files into a library archive. 
$(CBT_LIB)/libcbt.forte64g.a: $(forte64g)
	/hgsc/forte/bin/CC -xar -o $@  $(forte64g)
