#include "CompBioTools.hh"


class SeqInfo{
public:
  string mName;
  int mSize;
};

bool cmpSeqInfo(SeqInfo a,SeqInfo b){
  return(a.mSize < b.mSize);
}


int main(int argc,char**argv)
{
  if (argc<2){
	 cout<<endl;
	 cout<<"kjd-seqsize multifasta minsize"<<endl<<endl;
  }

  int minContig;
  if (argc > 2){
	 minContig = atoi(argv[2]);
  }else{
	 minContig = 1;
  }

  FASTAFile FA;

  SequenceVector SeqVec;
  //	cout<<"Read "<<argv[1]<<"..."<<flush;
  FA.Read(argv[1],SeqVec);
  //	cout<<"done."<<endl;

  vector<SeqInfo> Infos;
  for(int i = 0;i<SeqVec.size();i++){
	 SeqInfo temp;
	 temp.mName = SeqVec[i].mName;
	 temp.mSize = SeqVec[i].size();
	 Infos.push_back(temp);
  }

  // If -s, or any other option, given...
  sort(Infos.begin(),Infos.end(),cmpSeqInfo);
 
  int tsize = 0,numContigs = 0;
  
  if (Infos.size() > 1){
	 for(int i = 0;i< Infos.size();i++){
		if (Infos[i].mSize >= minContig){
		  cout<<Infos[i].mName<<"\t"<<Infos[i].mSize<<endl;
		  tsize+=Infos[i].mSize;
		  numContigs++;
		}
	 }
  }else{
	 tsize = Infos[0].mSize;
	 numContigs = 1;
  }
  cout<<"Num contigs >= "<<minContig<<" = "<<numContigs<<"\t";
  cout<<"Total Size = "<<tsize<<endl;
}


